
// Nightfire - Network Filter


#include <windows.h>
#include <stdio.h>

#define _l_MESSAGE_WARNING "\nYou received a console message." \
" Console messages can be used by things like the master servers to notify you of a problem." \
" Console messages can also be spoofed and be used to flood your console." \
" Don't blindly trust them.  You may prefer to disable them completely."
#define _h_MESSAGE_WARNING "\nYou received the Message of the Day." \
" The master can send you one at its discresion, but it usually won't." \
" Unfortunately its easy to spoof; NEVER trust it if it says to download something."
#define _O_MESSAGE_WARNING "\xff\xff\xff\xff" "lYou received a lovely message that'll spam your console soon.\n" \
" The 'outofdate' message WAS a nice way to tell servers they were out of date, but" \
" lately it's been sighted by people coming from non-masters.  If you" \
" know that you are up to date, best to ignore it or disable it with this thingy."

#define HLDS_BLOCK_HLBOOM 1
#define HLDS_BLOCK_CSDOS 1
#define HLDS_PREVENT_LONE_SPLITPACKETS 1

#define HLDS_DISABLE_MASTERMOTD 1
#define HLDS_DISABLE_GENERICMESSAGES 1
#define HLDS_DISABLE_OUTOFDATE 1

typedef void (*lpfn_accept)(void);
lpfn_accept orig_accept;

void sys_accept(void)
{
	(*orig_accept)();
}

typedef void (*lpfn_bind)(void);
lpfn_bind orig_bind;

void sys_bind(void)
{
	(*orig_bind)();
}


typedef void (*lpfn_closesocket)(void);
lpfn_closesocket orig_closesocket;

void sys_closesocket(void)
{
	(*orig_closesocket)();
}


typedef void (*lpfn_connect)(void);
lpfn_connect orig_connect;

void sys_connect(void)
{
   (*orig_connect)();
}

typedef void (*lpfn_getpeername)(void);
lpfn_getpeername orig_getpeername;

void sys_getpeername(void)
{
   (*orig_getpeername)();
}


typedef void (*lpfn_getsockname)(void);
lpfn_getsockname orig_getsockname;

void sys_getsockname(void)
{
   (*orig_getsockname)();
}


typedef void (*lpfn_getsockopt)(void);
lpfn_getsockopt orig_getsockopt;

void sys_getsockopt(void)
{
   (*orig_getsockopt)();
}


typedef void (*lpfn_htonl)(void);
lpfn_htonl orig_htonl;

void sys_htonl(void)
{
   (*orig_htonl)();
}


typedef void (*lpfn_htons)(void);
lpfn_htons orig_htons;

void sys_htons(void)
{
   (*orig_htons)();
}


typedef void (*lpfn_inet_addr)(void);
lpfn_inet_addr orig_inet_addr;

void sys_inet_addr(void)
{
   (*orig_inet_addr)();
}


typedef void (*lpfn_inet_ntoa)(void);
lpfn_inet_ntoa orig_inet_ntoa;

void sys_inet_ntoa(void)
{
   (*orig_inet_ntoa)();
}


typedef void (*lpfn_ioctlsocket)(void);
lpfn_ioctlsocket orig_ioctlsocket;

void sys_ioctlsocket(void)
{
   (*orig_ioctlsocket)();
}


typedef void (*lpfn_listen)(void);
lpfn_listen orig_listen;

void sys_listen(void)
{
   (*orig_listen)();
}


typedef void (*lpfn_ntohl)(void);
lpfn_ntohl orig_ntohl;

void sys_ntohl(void)
{
   (*orig_ntohl)();
}


typedef void (*lpfn_ntohs)(void);
lpfn_ntohs orig_ntohs;

void sys_ntohs(void)
{
   (*orig_ntohs)();
}

typedef void (*lpfn_recv)(void);
lpfn_recv orig_recv;

void sys_recv(void)
{
   (*orig_recv)();
}

const char * Cmd_GetFirstTokenStart(const char *text, int size, int SkipReturn) {

   int i = 0;

   //clear whitespace
   while(1) { //spaces and below are weeded out

      if(i >= size || text[i] == '\0' || (SkipReturn == 0 && text[i] == '\n')) { return(NULL); } //if we struck a null or return, there's nothing to see here.
      if(text[i] > 0x20) { break; }
      i++;
   }

   //comments are a pain...
   if(i < size-1 && text[i] == '/') {
      if(text[i+1] == '/') {

         //skip all text until a newline (or null)
         i++;
         i++;
         while(1) {

            if(i >= size || text[i] == '\0') { return(NULL); }
            if(text[i] == '\n') { break; }
            i++;
         }
         //skip the return (only skip 1; mirror HL in every way)
         i++;
         return(Cmd_GetFirstTokenStart(text + i, size - i, 1));
      }
      else if(text[i+1] == '*') {

         //skip all text until we see * and /
         i++;
         i++;
         while(1) {
            if(i+1 >= size || text[i] == '\0') { return(NULL); }
            if(text[i] == '*' && text[i+1] == '/') { break; }
           i++;
         }
         i++;
         i++;
         return(Cmd_GetFirstTokenStart(text + i, size - i, 1));
      }
   }

   //done with comments.  The next character should be a valid one--no more returning NULL.

   //Quotes.  We don't need to check to see if the quote is terminated; HL will accept it
   //either way.  We DO need to go one char past it though.

   if(i < size-1 && text[i] == '\"') { return(text+i+1); }

   // That's it.  There are more funny characters and parsing techniques, but for our
   // purposes they're all regular text.  return.
   return(text+i);
}


/* DESCRIPTION: sys_recvfrom
// hlboom is eight bytes long and always begins with 0xfeffffff.
// There is another fix in this code for an exploit which I am
// not familiar with.
//
// To print to the console, pass it a packet reading:
// 0xFFFFFFFF 'l' '\n' *message*. hmm pass it a packet reading FFFFFFFF 1 \n message :/ wonder if that works for nf cuz i di ek now it does i believe cuz tres showed me a screenshot saying "Received the deathpacket #1 etc hmm funny I could spam server consoles with it H AHLFMAOFMOAMOFMOA that would flood server unles it used my patch not only would you be able to spam rofl you'de be able to overflow string buffer  and? crash llolo lets test
//
// Limit size to 1400 bytes; that's the size of the array HL passes.
// I would suggest NOT banning people automatically that attack
// your server, simply because it's trivial to spoof the UDP
// packet's IP.  An auto-ban system would be very exploitable.
//
// The easiest way to kill a message is to wipe a bit.  Changing the
// return value might not work since not checking return values is
// what started this mess.
*/

// Query Optimization
 int last_i=0;
 int last_s=0;
 char l_info[1400];
 char l_status[1400];
 int len_info=0;
 int len_status=0;
 int last_p=0;

 char l_ip[14];// I dont Have a fucking clue lmao hmm  well
 int l_c=0;

// Query Optimization
typedef int(FAR PASCAL*lpfn_sendto)(IN SOCKET s, IN const char *buf, IN int len, IN int flags, IN const struct sockaddr *to, IN int tolen);
lpfn_sendto orig_sendto; 

typedef int (FAR PASCAL*lpfn_recvfrom)(IN SOCKET s, OUT char FAR * buf, IN int len, IN int flags, OUT struct sockaddr FAR *from, IN OUT int FAR * fromlen);
lpfn_recvfrom orig_recvfrom;

int FAR PASCAL sys_recvfrom(IN SOCKET s, OUT char FAR * buf, IN int len, IN int flags, OUT struct sockaddr FAR *from, IN OUT int FAR * fromlen)
{
   int splitnumber;
   int splittotal;
   int TokenLength;
   const char * token;
   const char * ptr;
  #if(HLDS_DISABLE_GENERICMESSAGES == 1)
   static int printedmessagewarning = 0;
   #endif
   #if(HLDS_DISABLE_MASTERMOTD == 1)
   static int printedmotdwarning = 0;
   #endif
   #if(HLDS_DISABLE_OUTOFDATE == 1)
   static int outofdatewarning = 0;
   #endif
   int returnCode=0;
   int counter=0;
   int tick=0; // Query Optimization
   int max_q=10; //queries per frame
   // Query Optimization
    
   int frame_q=0; // At least one query in a single frame

   returnCode = (*orig_recvfrom)(s, buf, len, flags, from, fromlen);
   // Start of Query Optimization

begin:
   if(returnCode < 9){
          if((unsigned char)buf[0] == 0x5C){
			    if(returnCode == 6){
							 tick = GetTickCount() - last_i;
							 if(tick < 1000){
								 if(max_q > 0){
									(*orig_sendto)(s, l_info, len_info, flags, from, fromlen);
									max_q--;

									goto begin;
								 }
								 return(0);
								  }
							 else{
								  last_p=1;
								  return(returnCode);
								  }
							 }
			    else if(returnCode == 8) {
					   tick = GetTickCount() - last_s;
					 if(tick < 1000){
						  if(max_q > 0){      
						  (*orig_sendto)(s, l_status, len_status, flags, from, fromlen);
						  max_q--;
								goto begin;
						  }
						  return(0);
								}
					  else {
						   last_p=2;
						   return(returnCode);
						   }
					  }
			    }																	
          }
	
	// End of Query Optimization
   
   // Misc Packets Crash Protection
   if((returnCode > 8) && (returnCode < 15))
   {
	   if(!(( unsigned char )buf[0] == 92)){
		   buf[0];
		   return(1);
	   }
   }

   //Nightfire "FE FF FF FF" Crash Prevention
   if ((( unsigned char )buf[0] == 254) && (( unsigned char )buf[1] == 255))
	  {
		  buf[0] = 0x00;
		  return(1); 
	  }

   if( ((unsigned char)buf[8] == 53) && ((unsigned char)buf[9] == 49) ) {
		int Av1 = 0;
		int Av2 = 746;
		Av1+=(unsigned char)buf[0];
		Av1+=(unsigned char)buf[1];
		Av1+=(unsigned char)buf[2];
		Av1+=(unsigned char)buf[3];
		Av1+=(unsigned char)buf[4];
		Av1+=(unsigned char)buf[5];
	    Av1+=(unsigned char)buf[6];
		if(Av1 == Av2){
			if(returnCode > 511){
				buf[0]=0;
				return(1);
				}
			}
		}

   if(returnCode > 4) {
                 
   // Start of Tres Exploit
   if(returnCode > 15) {
                  if (((unsigned char)buf[3] > 127) && ((unsigned char)buf[11] == 3)) {
                                 if (((unsigned char)buf[3] < 255) && ((unsigned char)buf[14] > 40) && ((unsigned char)buf[14] < 68) && ((unsigned char)buf[15] > 63) ) {
                                      // buf[14] = 0x00;
                                      buf[0] = 0x00;
                                      return(1);
                                      }
                                 }
                  }
   // End of Tres Exploit

      if(*(unsigned long *)buf == (unsigned long)0xFFFFFFFF) { //connectionless -1 little endian

         token = Cmd_GetFirstTokenStart(buf+4, returnCode-4, 0);
      }
      else if(*(unsigned long *)buf == (unsigned long)0xFFFFFFFE) { //split packet -2 le
         splitnumber = ((((unsigned char*)buf)[8] & 0xF0) >> 4);
         splittotal  =  (((unsigned char*)buf)[8] & 0x0F);

         //Split packet protections
         #if(HLDS_BLOCK_HLBOOM > 0)
         if(returnCode == 8 || (returnCode > 9 && splitnumber * 1391 + returnCode - 9 > 0xFAA)) { //boom, not my code
            #if(HLDS_BLOCK_HLBOOM > 1)
            if(sizeof("xxxxxHL-Boom packet received from 255.255.255.255x") < (unsigned int)len) {

               sprintf(buf, "\xff\xff\xff\xff" "lHL-Boom packet received from %d.%d.%d.%d",
					   from->sa_data[2],
					   from->sa_data[3],
					   from->sa_data[4],
					   from->sa_data[5]);
               return(strlen(buf));
            }
            #endif
            buf[0] = 0x00;
            return(1);
         }
         #endif
         #if(HLDS_PREVENT_LONE_SPLITPACKETS > 0)
         if(splittotal <= 1) { //Hl probably makes sure that splittotal and splitnumber aren't mismatched; this test here simply makes sure a single packet isn't trying to slip past us disguised as a split one
            #if(HLDS_PREVENT_LONE_SPLITPACKETS > 1)
            if(sizeof("xxxxxA split packet claiming to be the only packet in a series was intercepted from 255.255.255.255x") < (unsigned int)len) {

               sprintf(buf, "\xff\xff\xff\xff" "lA split packet claiming to be the only packet in a series was intercepted from %d.%d.%d.%d",
					   from->sa_data[2],
					   from->sa_data[3],
					   from->sa_data[4],
					   from->sa_data[5]);
               return(strlen(buf));
            }
            #endif
            buf[0] = 0x00;
            return(1);
         }
         #endif

         //At this point the split packet is clean (to the best of my knowledge at least).
         //We should let it pass UNLESS it ends up being a CONNECTIONLESS split packet.

         if(returnCode > 13 && (splitnumber == 0) && *(unsigned long *)(buf+9) == (unsigned long)0xFFFFFFFF) {
            //Connectionless SPLIT packet, tricky...
            token = Cmd_GetFirstTokenStart(buf+13, returnCode-13, 0);
         }
         else {
            return(returnCode);
         }
      }
      else {
         //packets that are neither type are to be passed on.
         return(returnCode);
      }

      //It's hard to track, I know, but at THIS stage in the program we have a connectionless
      //packet (of some sort) and "token" points to the beginning of its data.  Or null.


      if(token == NULL) { return(returnCode); }
      TokenLength = returnCode - (token - buf);
	  
	  if(returnCode > 511 && memcmp("getchallenge",token+4, 12)){
		buf[0] = 0x00;
		return(1); // Getchallenge Crash Prevention
	  }
	  if(returnCode > 511 && memcmp("challenge rcon",token+4, 14)){
		buf[0] = 0x00;
		return(1); // Challenge rcon Crash Prevention
	  }

      switch(token[0]) {
      #if(HLDS_BLOCK_CSDOS > 0)
      case 'c': //A 'c' could be part of 'connect'.  Test it.
         if(TokenLength > 6 && memcmp("onnect", token+1, 6) == 0) { //a connection, obviously
	
			 // Fake Players Prevention
			 int ipc = 2;
			 int ipcp = 0; // well watch what happens f i put cl_timout to the default 120 instead of 30
			 int ipcm = 4;
			 while(ipc<6)
			 {
				 if(l_ip[ipc] == from->sa_data[ipc]){
					 ipcp++;	
				 }
				 else{
					l_ip[ipc]=from->sa_data[ipc];
				 }
				 ipc++;
			 }
			 if(ipcm==ipcp){
				 if(GetTickCount() - l_c < 70000){
					return(0);
				 }
				}
			l_c=GetTickCount();

			//Nightfire FUCKING512 Crash Prevention (connect with >512 characters)  
			if(returnCode > 511){
				buf[0] = 0x00;
				return(1); 
			}
			counter=0;
			while(counter<returnCode)
			{
				if((unsigned char)buf[counter] == 37)
				{
					buf[0] = 0x00;
					return(1); 
				}
				counter++;
			}

            token += 7;
            //The problem of csdos resides in two slashes being next to each other.  There are probably other ways to break
            //it, and if they emerge I'll smash them.
            ptr = buf + returnCode-1;

            while(*ptr <= ' ' && ptr != token) { ptr--; }
            if(*ptr == '\\') { //busted
               #if(HLDS_BLOCK_CSDOS > 1)
               if(sizeof("xxxxxMalformed and possibly hostile connection packet received from 255.255.255.255x") < (unsigned int)len) {

                  sprintf(buf, "\xff\xff\xff\xff" "lMalformed and possibly hostile connection packet received from %d.%d.%d.%d",
			        from->sa_data[2],
			        from->sa_data[3],
			        from->sa_data[4],
			        from->sa_data[5]);
                  return(strlen(buf));
               }
               #endif
               buf[0] = 0x00;
               return(1);
            }

            //We're at the last readable text character.  Just in case, we should look for double
            //slashes in the name even though I'm not certain that's a risk.  I can't think
            //of any other way to slip it past us offhand...
            ptr--;
            while(ptr != token) {

               if(ptr[0] == '\\' && ptr[-1] == '\\') { //The off by one error at most means hitting the 't' in 'connect'
                  #if(HLDS_BLOCK_CSDOS > 1)
                  if(sizeof("xxxxxMalformed and possibly hostile connection packet received from 255.255.255.255x") < (unsigned int)len) {

                     sprintf(buf, "\xff\xff\xff\xff" "lMalformed and possibly hostile connection packet received from  %d.%d.%d.%d",
                       from->sa_data[2],
                       from->sa_data[3],
                       from->sa_data[4],
                       from->sa_data[5]);
                     return(strlen(buf));
                  }
                  #endif
                  buf[0] = 0x00;
                  return(1);
               }
               ptr--;
            }
         }
         break;
      #endif
      #if(HLDS_DISABLE_OUTOFDATE > 0)
      case 'O': //requestrestart
         #if(HLDS_DISABLE_OUTOFDATE > 1)
         buf[0] = 0x00;
         return(1);
         #else
         if(outofdatewarning == 0 && sizeof(_O_MESSAGE_WARNING) < (unsigned int)len) {

            sprintf(buf, _O_MESSAGE_WARNING);
            outofdatewarning++;
            return(sizeof(_O_MESSAGE_WARNING));
         }
         #endif
      #endif
      #if(HLDS_DISABLE_GENERICMESSAGES > 0)
      case 'l': //console message (generic)
         #if(HLDS_DISABLE_GENERICMESSAGES > 1)
         buf[0] = 0x00;
         return(1);
         #else
         if(printedmotdwarning == 0 && sizeof(_h_MESSAGE_WARNING) + returnCode < (unsigned int)len) {

            memcpy(buf+returnCode, _h_MESSAGE_WARNING, sizeof(_h_MESSAGE_WARNING));
            printedmotdwarning++;
            return(sizeof(_h_MESSAGE_WARNING) + returnCode);
         }
         #endif
      #endif
      #if(HLDS_DISABLE_MASTERMOTD > 0)
      case 'h': //console message (motd)
         #if(HLDS_DISABLE_MASTERMOTD > 1)
         buf[0] = 0x00;
         return(1);
         #else
         if(printedmessagewarning == 0 && sizeof(_l_MESSAGE_WARNING) + returnCode < (unsigned int)len) {

            memcpy(buf+returnCode, _l_MESSAGE_WARNING, sizeof(_l_MESSAGE_WARNING));
            printedmessagewarning++;
            return(sizeof(_l_MESSAGE_WARNING) + returnCode);
         }
         #endif
      #endif
      }
   }
   return(returnCode);
}


typedef void (*lpfn_select)(void);
lpfn_select orig_select;

void sys_select(void)
{
   (*orig_select)();
}


typedef void (*lpfn_send)(void);
lpfn_send orig_send;

void sys_send(void)
{
   (*orig_send)();
}

 

// Query Optimization
int FAR PASCAL sys_sendto(IN SOCKET s, IN const char *buf, IN int len, IN int flags, IN const struct sockaddr *to, IN int tolen)
{
    if(last_p==1) {
               memcpy(l_info, buf, len);
               len_info = len;
               last_i = GetTickCount();
			   last_p=0;
               }
    else if(last_p==2) {
               memcpy(l_status, buf, len);
               len_status = len;
               last_s = GetTickCount();
			   last_p=0;
			}
	//query anything flood fix
	if(len < 25){
		if( (unsigned char)buf[1] == 102 ){return(0);}
		}
               return((*orig_sendto)(s, buf, len, flags, to, tolen));
}

// perfect I think xD lets the only difference being that it will always return the query except it wont go through nightfire it will just send it directly is that good dunno prolly best we test xD
/*

typedef void (*lpfn_sendto)(void);
lpfn_sendto orig_sendto;
void sys_sendto(void)
{
   (*orig_sendto)();
}
*/

typedef void (*lpfn_setsockopt)(void);
lpfn_setsockopt orig_setsockopt;

void sys_setsockopt(void)
{
   (*orig_setsockopt)();
}


typedef void (*lpfn_shutdown)(void);
lpfn_shutdown orig_shutdown;

//I could be useful
void sys_shutdown(void)
{
   (*orig_shutdown)();
}


typedef void (*lpfn_socket)(void);
lpfn_socket orig_socket;

void sys_socket(void)
{
   (*orig_socket)();
}


typedef void (*lpfn_MigrateWinsockConfiguration)(void);
lpfn_MigrateWinsockConfiguration orig_MigrateWinsockConfiguration;

void sys_MigrateWinsockConfiguration(void)
{
   (*orig_MigrateWinsockConfiguration)();
}


typedef void (*lpfn_gethostbyaddr)(void);
lpfn_gethostbyaddr orig_gethostbyaddr;

void sys_gethostbyaddr(void)
{
   (*orig_gethostbyaddr)();
}


typedef void (*lpfn_gethostbyname)(void);
lpfn_gethostbyname orig_gethostbyname;

void sys_gethostbyname(void)
{
   (*orig_gethostbyname)();
}


typedef void (*lpfn_getprotobyname)(void);
lpfn_getprotobyname orig_getprotobyname;

void sys_getprotobyname(void)
{
   (*orig_getprotobyname)();
}


typedef void (*lpfn_getprotobynumber)(void);
lpfn_getprotobynumber orig_getprotobynumber;

void sys_getprotobynumber(void)
{
   (*orig_getprotobynumber)();
}


typedef void (*lpfn_getservbyname)(void);
lpfn_getservbyname orig_getservbyname;

void sys_getservbyname(void)
{
   (*orig_getservbyname)();
}


typedef void (*lpfn_getservbyport)(void);
lpfn_getservbyport orig_getservbyport;

void sys_getservbyport(void)
{
   (*orig_getservbyport)();
}


typedef void (*lpfn_gethostname)(void);
lpfn_gethostname orig_gethostname;

void sys_gethostname(void)
{
   (*orig_gethostname)();
}


typedef void (*lpfn_WSAAsyncSelect)(void);
lpfn_WSAAsyncSelect orig_WSAAsyncSelect;

void sys_WSAAsyncSelect(void)
{
   (*orig_WSAAsyncSelect)();
}


typedef void (*lpfn_WSAAsyncGetHostByAddr)(void);
lpfn_WSAAsyncGetHostByAddr orig_WSAAsyncGetHostByAddr;

void sys_WSAAsyncGetHostByAddr(void)
{
   (*orig_WSAAsyncGetHostByAddr)();
}


typedef void (*lpfn_WSAAsyncGetHostByName)(void);
lpfn_WSAAsyncGetHostByName orig_WSAAsyncGetHostByName;

void sys_WSAAsyncGetHostByName(void)
{
   (*orig_WSAAsyncGetHostByName)();
}


typedef void (*lpfn_WSAAsyncGetProtoByNumber)(void);
lpfn_WSAAsyncGetProtoByNumber orig_WSAAsyncGetProtoByNumber;

void sys_WSAAsyncGetProtoByNumber(void)
{
   (*orig_WSAAsyncGetProtoByNumber)();
}


typedef void (*lpfn_WSAAsyncGetProtoByName)(void);
lpfn_WSAAsyncGetProtoByName orig_WSAAsyncGetProtoByName;

void sys_WSAAsyncGetProtoByName(void)
{
   (*orig_WSAAsyncGetProtoByName)();
}


typedef void (*lpfn_WSAAsyncGetServByPort)(void);
lpfn_WSAAsyncGetServByPort orig_WSAAsyncGetServByPort;

void sys_WSAAsyncGetServByPort(void)
{
   (*orig_WSAAsyncGetServByPort)();
}


typedef void (*lpfn_WSAAsyncGetServByName)(void);
lpfn_WSAAsyncGetServByName orig_WSAAsyncGetServByName;

void sys_WSAAsyncGetServByName(void)
{
   (*orig_WSAAsyncGetServByName)();
}


typedef void (*lpfn_WSACancelAsyncRequest)(void);
lpfn_WSACancelAsyncRequest orig_WSACancelAsyncRequest;

void sys_WSACancelAsyncRequest(void)
{
   (*orig_WSACancelAsyncRequest)();
}


typedef void (*lpfn_WSASetBlockingHook)(void);
lpfn_WSASetBlockingHook orig_WSASetBlockingHook;

void sys_WSASetBlockingHook(void)
{
   (*orig_WSASetBlockingHook)();
}


typedef void (*lpfn_WSAUnhookBlockingHook)(void);
lpfn_WSAUnhookBlockingHook orig_WSAUnhookBlockingHook;

void sys_WSAUnhookBlockingHook(void)
{
   (*orig_WSAUnhookBlockingHook)();
}


typedef void (*lpfn_WSAGetLastError)(void);
lpfn_WSAGetLastError orig_WSAGetLastError;

void sys_WSAGetLastError(void)
{
   (*orig_WSAGetLastError)();
}


typedef void (*lpfn_WSASetLastError)(void);
lpfn_WSASetLastError orig_WSASetLastError;

void sys_WSASetLastError(void)
{
   (*orig_WSASetLastError)();
}


typedef void (*lpfn_WSACancelBlockingCall)(void);
lpfn_WSACancelBlockingCall orig_WSACancelBlockingCall;

void sys_WSACancelBlockingCall(void)
{
   (*orig_WSACancelBlockingCall)();
}


typedef void (*lpfn_WSAIsBlocking)(void);
lpfn_WSAIsBlocking orig_WSAIsBlocking;

void sys_WSAIsBlocking(void)
{
   (*orig_WSAIsBlocking)();
}


typedef void (*lpfn_WSAStartup)(void);
lpfn_WSAStartup orig_WSAStartup;

void sys_WSAStartup(void)
{
   (*orig_WSAStartup)();
}

//I could be useful too
typedef void (*lpfn_WSACleanup)(void);
lpfn_WSACleanup orig_WSACleanup;

void sys_WSACleanup(void)
{
   (*orig_WSACleanup)();
}


typedef void (*lpfn___WSAFDIsSet)(void);
lpfn___WSAFDIsSet orig___WSAFDIsSet;

void sys___WSAFDIsSet(void)
{
   (*orig___WSAFDIsSet)();
}


typedef void (*lpfn_WEP)(void);
lpfn_WEP orig_WEP;

void sys_WEP(void)
{
   (*orig_WEP)();
}


typedef void (*lpfn_WSApSetPostRoutine)(void);
lpfn_WSApSetPostRoutine orig_WSApSetPostRoutine;

void sys_WSApSetPostRoutine(void)
{
   (*orig_WSApSetPostRoutine)();
}


typedef void (*lpfn_inet_network)(void);
lpfn_inet_network orig_inet_network;

void sys_inet_network(void)
{
   (*orig_inet_network)();
}


typedef void (*lpfn_getnetbyname)(void);
lpfn_getnetbyname orig_getnetbyname;

void sys_getnetbyname(void)
{
   (*orig_getnetbyname)();
}


typedef void (*lpfn_rcmd)(void);
lpfn_rcmd orig_rcmd;

void sys_rcmd(void)
{
   (*orig_rcmd)();
}


typedef void (*lpfn_rexec)(void);
lpfn_rexec orig_rexec;

void sys_rexec(void)
{
   (*orig_rexec)();
}


typedef void (*lpfn_rresvport)(void);
lpfn_rresvport orig_rresvport;

void sys_rresvport(void)
{
   (*orig_rresvport)();
}


typedef void (*lpfn_sethostname)(void);
lpfn_sethostname orig_sethostname;

void sys_sethostname(void)
{
   (*orig_sethostname)();
}


typedef void (*lpfn_dn_expand)(void);
lpfn_dn_expand orig_dn_expand;

void sys_dn_expand(void)
{
   (*orig_dn_expand)();
}


typedef void (*lpfn_WSARecvEx)(void);
lpfn_WSARecvEx orig_WSARecvEx;

void sys_WSARecvEx(void)
{
   (*orig_WSARecvEx)();
}


typedef void (*lpfn_s_perror)(void);
lpfn_s_perror orig_s_perror;

void sys_s_perror(void)
{
   (*orig_s_perror)();
}


typedef void (*lpfn_GetAddressByNameA)(void);
lpfn_GetAddressByNameA orig_GetAddressByNameA;

void sys_GetAddressByNameA(void)
{
   (*orig_GetAddressByNameA)();
}


typedef void (*lpfn_GetAddressByNameW)(void);
lpfn_GetAddressByNameW orig_GetAddressByNameW;

void sys_GetAddressByNameW(void)
{
   (*orig_GetAddressByNameW)();
}


typedef void (*lpfn_EnumProtocolsA)(void);
lpfn_EnumProtocolsA orig_EnumProtocolsA;

void sys_EnumProtocolsA(void)
{
   (*orig_EnumProtocolsA)();
}


typedef void (*lpfn_EnumProtocolsW)(void);
lpfn_EnumProtocolsW orig_EnumProtocolsW;

void sys_EnumProtocolsW(void)
{
   (*orig_EnumProtocolsW)();
}


typedef void (*lpfn_GetTypeByNameA)(void);
lpfn_GetTypeByNameA orig_GetTypeByNameA;

void sys_GetTypeByNameA(void)
{
   (*orig_GetTypeByNameA)();
}


typedef void (*lpfn_GetTypeByNameW)(void);
lpfn_GetTypeByNameW orig_GetTypeByNameW;

void sys_GetTypeByNameW(void)
{
   (*orig_GetTypeByNameW)();
}


typedef void (*lpfn_GetNameByTypeA)(void);
lpfn_GetNameByTypeA orig_GetNameByTypeA;

void sys_GetNameByTypeA(void)
{
   (*orig_GetNameByTypeA)();
}


typedef void (*lpfn_GetNameByTypeW)(void);
lpfn_GetNameByTypeW orig_GetNameByTypeW;

void sys_GetNameByTypeW(void)
{
   (*orig_GetNameByTypeW)();
}


typedef void (*lpfn_SetServiceA)(void);
lpfn_SetServiceA orig_SetServiceA;

void sys_SetServiceA(void)
{
   (*orig_SetServiceA)();
}


typedef void (*lpfn_SetServiceW)(void);
lpfn_SetServiceW orig_SetServiceW;

void sys_SetServiceW(void)
{
   (*orig_SetServiceW)();
}


typedef void (*lpfn_GetServiceA)(void);
lpfn_GetServiceA orig_GetServiceA;

void sys_GetServiceA(void)
{
   (*orig_GetServiceA)();
}


typedef void (*lpfn_GetServiceW)(void);
lpfn_GetServiceW orig_GetServiceW;

void sys_GetServiceW(void)
{
   (*orig_GetServiceW)();
}


typedef void (*lpfn_NPLoadNameSpaces)(void);
lpfn_NPLoadNameSpaces orig_NPLoadNameSpaces;

void sys_NPLoadNameSpaces(void)
{
   (*orig_NPLoadNameSpaces)();
}


typedef void (*lpfn_TransmitFile)(void);
lpfn_TransmitFile orig_TransmitFile;

void sys_TransmitFile(void)
{
   (*orig_TransmitFile)();
}


typedef void (*lpfn_AcceptEx)(void);
lpfn_AcceptEx orig_AcceptEx;

void sys_AcceptEx(void)
{
   (*orig_AcceptEx)();
}


typedef void (*lpfn_GetAcceptExSockaddrs)(void);
lpfn_GetAcceptExSockaddrs orig_GetAcceptExSockaddrs;

void sys_GetAcceptExSockaddrs(void)
{
   (*orig_GetAcceptExSockaddrs)();
}


//  That's all the stubs, now for the boilerplate code.

BOOL Initialize(void)
{
   HMODULE hModule;
   char szOrigDll[MAX_PATH];
   FILE* fp = NULL;
   unsigned int temp = 0;

   /* First we check and see if the user specified a file.  Otherwise we
   // by default check in the system directory.  MAX_PATH adhered to at
   // all times.
   */
   fp = fopen("w32proxy.cfg", "r");
   if (!fp) {
      GetSystemDirectory(szOrigDll, MAX_PATH);
      if( !((strlen(szOrigDll) + strlen("\\wsock32.dll")) < MAX_PATH) ) { return FALSE; }
      strcat(szOrigDll, "\\wsock32.dll");
   }
   else {
      fgets(szOrigDll, MAX_PATH, fp);
      temp = strlen(szOrigDll);
	temp--;
      if(szOrigDll[temp] == '\n' || szOrigDll[temp] == '\r') {
         szOrigDll[temp] = '\0';
      }
      fclose(fp);
   }

   hModule = LoadLibrary(szOrigDll);
   if( hModule == NULL ) return FALSE;

   orig_accept = (lpfn_accept)GetProcAddress(hModule, "accept");
   orig_bind = (lpfn_bind)GetProcAddress(hModule, "bind");
   orig_closesocket = (lpfn_closesocket)GetProcAddress(hModule, "closesocket");
   orig_connect = (lpfn_connect)GetProcAddress(hModule, "connect");
   orig_getpeername = (lpfn_getpeername)GetProcAddress(hModule, "getpeername");
   orig_getsockname = (lpfn_getsockname)GetProcAddress(hModule, "getsockname");
   orig_getsockopt = (lpfn_getsockopt)GetProcAddress(hModule, "getsockopt");
   orig_htonl = (lpfn_htonl)GetProcAddress(hModule, "htonl");
   orig_htons = (lpfn_htons)GetProcAddress(hModule, "htons");
   orig_inet_addr = (lpfn_inet_addr)GetProcAddress(hModule, "inet_addr");
   orig_inet_ntoa = (lpfn_inet_ntoa)GetProcAddress(hModule, "inet_ntoa");
   orig_ioctlsocket = (lpfn_ioctlsocket)GetProcAddress(hModule, "ioctlsocket");
   orig_listen = (lpfn_listen)GetProcAddress(hModule, "listen");
   orig_ntohl = (lpfn_ntohl)GetProcAddress(hModule, "ntohl");
   orig_ntohs = (lpfn_ntohs)GetProcAddress(hModule, "ntohs");
   orig_recv = (lpfn_recv)GetProcAddress(hModule, "recv");
   orig_recvfrom = (lpfn_recvfrom)GetProcAddress(hModule, "recvfrom");
   orig_select = (lpfn_select)GetProcAddress(hModule, "select");
   orig_send = (lpfn_send)GetProcAddress(hModule, "send");
   orig_sendto = (lpfn_sendto)GetProcAddress(hModule, "sendto");
   orig_setsockopt = (lpfn_setsockopt)GetProcAddress(hModule, "setsockopt");
   orig_shutdown = (lpfn_shutdown)GetProcAddress(hModule, "shutdown");
   orig_socket = (lpfn_socket)GetProcAddress(hModule, "socket");
   orig_MigrateWinsockConfiguration = (lpfn_MigrateWinsockConfiguration)GetProcAddress(hModule, "MigrateWinsockConfiguration");
   orig_gethostbyaddr = (lpfn_gethostbyaddr)GetProcAddress(hModule, "gethostbyaddr");
   orig_gethostbyname = (lpfn_gethostbyname)GetProcAddress(hModule, "gethostbyname");
   orig_getprotobyname = (lpfn_getprotobyname)GetProcAddress(hModule, "getprotobyname");
   orig_getprotobynumber = (lpfn_getprotobynumber)GetProcAddress(hModule, "getprotobynumber");
   orig_getservbyname = (lpfn_getservbyname)GetProcAddress(hModule, "getservbyname");
   orig_getservbyport = (lpfn_getservbyport)GetProcAddress(hModule, "getservbyport");
   orig_gethostname = (lpfn_gethostname)GetProcAddress(hModule, "gethostname");
   orig_WSAAsyncSelect = (lpfn_WSAAsyncSelect)GetProcAddress(hModule, "WSAAsyncSelect");
   orig_WSAAsyncGetHostByAddr = (lpfn_WSAAsyncGetHostByAddr)GetProcAddress(hModule, "WSAAsyncGetHostByAddr");
   orig_WSAAsyncGetHostByName = (lpfn_WSAAsyncGetHostByName)GetProcAddress(hModule, "WSAAsyncGetHostByName");
   orig_WSAAsyncGetProtoByNumber = (lpfn_WSAAsyncGetProtoByNumber)GetProcAddress(hModule, "WSAAsyncGetProtoByNumber");
   orig_WSAAsyncGetProtoByName = (lpfn_WSAAsyncGetProtoByName)GetProcAddress(hModule, "WSAAsyncGetProtoByName");
   orig_WSAAsyncGetServByPort = (lpfn_WSAAsyncGetServByPort)GetProcAddress(hModule, "WSAAsyncGetServByPort");
   orig_WSAAsyncGetServByName = (lpfn_WSAAsyncGetServByName)GetProcAddress(hModule, "WSAAsyncGetServByName");
   orig_WSACancelAsyncRequest = (lpfn_WSACancelAsyncRequest)GetProcAddress(hModule, "WSACancelAsyncRequest");
   orig_WSASetBlockingHook = (lpfn_WSASetBlockingHook)GetProcAddress(hModule, "WSASetBlockingHook");
   orig_WSAUnhookBlockingHook = (lpfn_WSAUnhookBlockingHook)GetProcAddress(hModule, "WSAUnhookBlockingHook");
   orig_WSAGetLastError = (lpfn_WSAGetLastError)GetProcAddress(hModule, "WSAGetLastError");
   orig_WSASetLastError = (lpfn_WSASetLastError)GetProcAddress(hModule, "WSASetLastError");
   orig_WSACancelBlockingCall = (lpfn_WSACancelBlockingCall)GetProcAddress(hModule, "WSACancelBlockingCall");
   orig_WSAIsBlocking = (lpfn_WSAIsBlocking)GetProcAddress(hModule, "WSAIsBlocking");
   orig_WSAStartup = (lpfn_WSAStartup)GetProcAddress(hModule, "WSAStartup");
   orig_WSACleanup = (lpfn_WSACleanup)GetProcAddress(hModule, "WSACleanup");
   orig___WSAFDIsSet = (lpfn___WSAFDIsSet)GetProcAddress(hModule, "__WSAFDIsSet");
   orig_WEP = (lpfn_WEP)GetProcAddress(hModule, "WEP");
   orig_WSApSetPostRoutine = (lpfn_WSApSetPostRoutine)GetProcAddress(hModule, "WSApSetPostRoutine");
   orig_inet_network = (lpfn_inet_network)GetProcAddress(hModule, "inet_network");
   orig_getnetbyname = (lpfn_getnetbyname)GetProcAddress(hModule, "getnetbyname");
   orig_rcmd = (lpfn_rcmd)GetProcAddress(hModule, "rcmd");
   orig_rexec = (lpfn_rexec)GetProcAddress(hModule, "rexec");
   orig_rresvport = (lpfn_rresvport)GetProcAddress(hModule, "rresvport");
   orig_sethostname = (lpfn_sethostname)GetProcAddress(hModule, "sethostname");
   orig_dn_expand = (lpfn_dn_expand)GetProcAddress(hModule, "dn_expand");
   orig_WSARecvEx = (lpfn_WSARecvEx)GetProcAddress(hModule, "WSARecvEx");
   orig_s_perror = (lpfn_s_perror)GetProcAddress(hModule, "s_perror");
   orig_GetAddressByNameA = (lpfn_GetAddressByNameA)GetProcAddress(hModule, "GetAddressByNameA");
   orig_GetAddressByNameW = (lpfn_GetAddressByNameW)GetProcAddress(hModule, "GetAddressByNameW");
   orig_EnumProtocolsA = (lpfn_EnumProtocolsA)GetProcAddress(hModule, "EnumProtocolsA");
   orig_EnumProtocolsW = (lpfn_EnumProtocolsW)GetProcAddress(hModule, "EnumProtocolsW");
   orig_GetTypeByNameA = (lpfn_GetTypeByNameA)GetProcAddress(hModule, "GetTypeByNameA");
   orig_GetTypeByNameW = (lpfn_GetTypeByNameW)GetProcAddress(hModule, "GetTypeByNameW");
   orig_GetNameByTypeA = (lpfn_GetNameByTypeA)GetProcAddress(hModule, "GetNameByTypeA");
   orig_GetNameByTypeW = (lpfn_GetNameByTypeW)GetProcAddress(hModule, "GetNameByTypeW");
   orig_SetServiceA = (lpfn_SetServiceA)GetProcAddress(hModule, "SetServiceA");
   orig_SetServiceW = (lpfn_SetServiceW)GetProcAddress(hModule, "SetServiceW");
   orig_GetServiceA = (lpfn_GetServiceA)GetProcAddress(hModule, "GetServiceA");
   orig_GetServiceW = (lpfn_GetServiceW)GetProcAddress(hModule, "GetServiceW");
   orig_NPLoadNameSpaces = (lpfn_NPLoadNameSpaces)GetProcAddress(hModule, "NPLoadNameSpaces");
   orig_TransmitFile = (lpfn_TransmitFile)GetProcAddress(hModule, "TransmitFile");
   orig_AcceptEx = (lpfn_AcceptEx)GetProcAddress(hModule, "AcceptEx");
   orig_GetAcceptExSockaddrs = (lpfn_GetAcceptExSockaddrs)GetProcAddress(hModule, "GetAcceptExSockaddrs");

   //We might want to make sure these aren't null, but it'll be apparent if something we call isn't.
   return TRUE;
}

BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
   if( dwReason == DLL_PROCESS_ATTACH )
   {
      DisableThreadLibraryCalls(hInstance);
      return Initialize();
   }

   return TRUE;
}
