﻿Public Class GetDirectory
    Public invaliddirectory As String = "This directory does not seem to contain a valid installation of Nightfire. Please browse to the correct folder."
    Private Sub Browsedir_Click(sender As System.Object, e As System.EventArgs) Handles Browsedir.Click
        Dim browsefolder As New FolderBrowserDialog
        With browsefolder
            browsefolder.RootFolder = Environment.SpecialFolder.MyComputer
            browsefolder.ShowDialog()
            If Windows.Forms.DialogResult.OK Then
                If browsefolder.SelectedPath = "" Then
                    Directorybox.Text = Directorybox.Text
                Else
                    Directorybox.Text = browsefolder.SelectedPath
                End If
            End If
        End With
    End Sub

    Private Sub next_home_Click(sender As System.Object, e As System.EventArgs) Handles next_getdirectory.Click
        If Directorybox.Text = "" Then
            MsgBox("You did not select a folder. Please select a folder before attempting to install the update.")
            Exit Sub
        End If
        If Directorybox.Text.EndsWith("\") Or Directorybox.Text.EndsWith("/") Then
            Directorybox.Text = Directorybox.Text.Substring(0, Directorybox.Text.Length - 1)
        End If
        If Not IO.Directory.Exists(Directorybox.Text) Then
            MsgBox("This directory does not exist. Please try again.")
            Exit Sub
        End If
        If Directorybox.Text.EndsWith("bond") Then
            MsgBox("This update is meant to be installed to the Nightfire folder, not bond. Please select the root Nightfire folder.")
            Exit Sub
        End If
        If Not IO.Directory.Exists(Directorybox.Text & "\bond") Then
            MsgBox(invaliddirectory)
            Exit Sub
        End If
        If Not IO.File.Exists(Directorybox.Text & "\zlib.dll") Then
            MsgBox(invaliddirectory)
            Exit Sub
        End If
        Me.Hide()
        InstallPatch.Show()
    End Sub

    Private Sub GetDirectory_FormClosing1(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        WelcomeScreen.exitapplication()
    End Sub

    Private Sub Back_togetdirectory_Click(sender As System.Object, e As System.EventArgs) Handles Back_togetdirectory.Click
        Me.Hide()
        WelcomeScreen.Show()
    End Sub
End Class