﻿Public Class InstallPatch

    Private Sub next_installpatch_Click(sender As System.Object, e As System.EventArgs) Handles next_installpatch.Click
        If Not IO.Directory.Exists("Data") Then
            MsgBox("The Data directory was not found. Please unzip the entire patch before attempting to install.", MsgBoxStyle.Critical)
            Me.Close()
        End If
        Dim bond As Process() = Process.GetProcessesByName("Bond")
        Dim bond2 As Process() = Process.GetProcessesByName("Bond2")
        Dim mapd As Process() = Process.GetProcessesByName("MapDownloader")
        For Each a In bond
            Try
                a.Kill()
            Catch ex As Exception
                MsgBox("Nightfire was found running on your system and could not be closed. Please exit the game before updating. This wizard will now exit.", MsgBoxStyle.Critical)
                WelcomeScreen.ExitApplication()
            End Try
        Next
        For Each b In bond2
            Try
                b.Kill()
            Catch ex As Exception
                MsgBox("Nightfire was found running on your system and could not be closed. Please exit the game before updating. This wizard will now exit.", MsgBoxStyle.Critical)
                WelcomeScreen.ExitApplication()
            End Try
        Next
        For Each c In mapd
            Try
                c.Kill()
            Catch ex As Exception
                MsgBox("The Nightfire Map Downloader was found running on your system and could not be closed. Please ensure this process is closed before updating.", MsgBoxStyle.Critical)
            End Try
        Next

        Try
            Dim folder As String = GetDirectory.Directorybox.Text
            IO.File.Delete(folder & "\d3dx8d.dll")
            IO.File.Delete(folder & "\GbxRuntime.dll")
            IO.File.Delete(folder & "\msvcrt.dll")
            IO.File.Delete(folder & "\gamespy.ico")
            IO.File.Delete(folder & "\DrvMgt.dll")
            IO.File.Delete(folder & "\Secdrv.sys")
            IO.File.Delete(folder & "\00000000.016")
            IO.File.Delete(folder & "\00000000.256")
        Catch ex As Exception
        End Try
        Try
            CopyDirectory("data", GetDirectory.Directorybox.Text)
        Catch ex As Exception
            If ex.Message.StartsWith("Access to the path") Then
                MsgBox(ex.Message & " Check to make sure the file is not set to read-only by rightclicking on it and then clicking properties.", MsgBoxStyle.Critical)
            Else
                MsgBox(ex.Message, MsgBoxStyle.Critical)
            End If
            MsgBox("Installation of the update failed. This wizard will now exit. For help, contact click4dylan@live.com or visit http://007nightfire.net.", MsgBoxStyle.Critical)
            WelcomeScreen.ExitApplication()
        End Try

        Me.Hide()
        InstallSuccessful.Show()
    End Sub

    Private Sub Back_togetdirectory_Click(sender As System.Object, e As System.EventArgs) Handles Back_togetdirectory.Click
        Me.Hide()
        GetDirectory.Show()
    End Sub

    Public Sub CopyDirectory(ByVal strSrc As String, ByVal strDest As String) 'source: http://bytes.com/topic/visual-basic-net/answers/365349-copying-all-contents-one-folder-into-another
        Dim dirInfo As New System.IO.DirectoryInfo(strSrc)
        Dim fsInfo As System.IO.FileSystemInfo

        If Not System.IO.Directory.Exists(strDest) Then
            System.IO.Directory.CreateDirectory(strDest)
        End If

        For Each fsInfo In dirInfo.GetFileSystemInfos
            Dim strDestFileName As String = System.IO.Path.Combine(strDest, fsInfo.Name)
            Try
                If IO.File.GetAttributes(strDestFileName) <> IO.FileAttributes.Normal Then
                    IO.File.SetAttributes(strDestFileName, IO.FileAttributes.Normal)
                End If
            Catch
            End Try
            If TypeOf fsInfo Is System.IO.FileInfo Then
                System.IO.File.Copy(fsInfo.FullName, strDestFileName, True)
                'This will overwrite files that already exist
            Else
                CopyDirectory(fsInfo.FullName, strDestFileName)
            End If

        Next
    End Sub

    Private Sub InstallPatch_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        WelcomeScreen.ExitApplication()
    End Sub
End Class