﻿Public Class WelcomeScreen
    Public programfiles As String = System.Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles)
    Public showquestions As Boolean = True
    Public defaultnightfirefolder As String = programfiles & "\EA Games\Nightfire"
    Public defaultexists As Boolean = False
    Public killed As Boolean = False
    Public cancel As Boolean = False

    Private Sub WelcomeScreen_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        killed = True
    End Sub

    Private Sub Page1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        If Not IO.Directory.Exists("Data") Then
            MsgBox("The Data directory was not found. Please unzip the entire patch before attempting to install.", MsgBoxStyle.Critical)
            Me.Close()
        End If
        If IO.Directory.Exists(defaultnightfirefolder & "\bond") Then
            If IO.File.Exists(defaultnightfirefolder & "\bond\assets.007") Or IO.File.Exists(defaultnightfirefolder & "\zlib.dll") Then
                GetDirectory.Directorybox.Text = defaultnightfirefolder
                MsgBox("The default Nightfire directory has been detected as " & defaultnightfirefolder & ". If this is incorrect, you can change it at a later stage")
                showquestions = False
                defaultexists = True
            End If
        End If
    End Sub

    Private Sub next_home_Click(sender As System.Object, e As System.EventArgs) Handles next_home.Click
        If showquestions = False Then
            Me.Hide()
            GetDirectory.Show()
            Exit Sub
        End If
        Dim dirquestion = MsgBox("Do you know what folder your Nightfire directory is installed to?", MsgBoxStyle.YesNo)
        If dirquestion = MsgBoxResult.No Then
            MsgBox("Please launch Nightfire for the installer to detect which directory the patch should install to.", MsgBoxStyle.OkOnly)
            WaitingforProcesses.Show()
            next_home.Enabled = False
            Do
                Dim list = Process.GetProcesses()
                For Each a In list
                    Application.DoEvents()
                    Threading.Thread.Sleep(10)
                    If cancel = True Then
                        next_home.Enabled = True
                        Exit Sub
                    ElseIf killed = True Then
                        ExitApplication()
                        Exit Sub
                    End If
                    If a.ProcessName.ToLower.StartsWith("bond") And (a.MainWindowTitle.ToLower = "nightfire") Then 'is server bond_ded
                        Dim b = a.MainModule.FileName
                        Dim c = b.Split("\")
                        b = b.Remove(b.Length - c(c.Length - 1).Length - 1)
                        Try
                            a.Kill()
                        Catch ex As Exception
                            MsgBox("Failed to close Nightfire, please close the game before continuing.")
                        End Try
                        GetDirectory.Directorybox.Text = b
                        WaitingforProcesses.Hide()
                        MsgBox("Your Nightfire folder has been detected as " & b)
                        Exit Do
                    End If
                Next
            Loop
        Else
            Me.Hide()
            GetDirectory.Show()
        End If
        Me.Hide()
        GetDirectory.Show()
    End Sub
    Public Function ExitApplication()
        Me.Close()
        Return 0
    End Function
End Class
